%
% Exemplo para a máquina de lavar-roupas.
%

clc; clear;

Peso=[-20 -10 0 20
    10 30 30 50
    40 65 65 90
    75 90 100 120];

% Gerar gráfico do peso;
t=linspace(0,100,101);
for i=1:4
  Pvalues(:,i)=TRAP(t,Peso(i,:))';
end
plot(t,Pvalues,'linewidth',4);
axis([0 100 0 1.1]);
text(0,1.05,'ML');
text(30,1.05,'L');
text(65,1.05,'P');
text(95,1.05,'MP');
grid;
print -depsc mfpeso.eps
    
Sujeira=[-20 0 20
    10 30 50
    40 70 100
    80 100 120];

% Gerar gráfico da sujeira;
t=linspace(0,100,101);
for i=1:4
  Svalues(:,i)=TRI(t,Sujeira(i,:))';
end
plot(t,Svalues,'linewidth',4);
axis([0 100 0 1.1]);
text(0,1.05,'QL');
text(30,1.05,'S');
text(70,1.05,'MS');
text(100,1.05,'ES');
grid;
print -depsc mfsujeira.eps    
    
Detergente=[0 10 10 20;
  20 30 30 40;
  40 50 50 60;
  60 70 70 80;
  80 90 100 120];

% Gerar gráfico do detergente;
t=linspace(0,100,101);
for i=1:5
  Dvalues(:,i)=TRAP(t,Detergente(i,:))';
end
plot(t,Dvalues,'linewidth',4);
axis([0 100 0 1.1]);
text(10,1.05,'MP');
text(30,1.05,'P');
text(50,1.05,'M');
text(70,1.05,'E');
text(95,1.05,'Max');
grid;
print -depsc mfdetergente.eps   

plot(t,max(min(0.25,TRAP(t,Detergente(1,:))),min(0.25,TRAP(t,Detergente(2,:)))),'linewidth',4);
axis([0 100 0 0.3]);
text(20,0.26,'Output');
grid;
print -depsc mfdetergentoutput.eps

Rules=[1 2 3 3
    2 2 3 4
    3 3 4 4
    3 4 5 5];  

t=linspace(0,100,31);
for p=1:length(t)
    for s=1:length(t);
        y(p,s)=0;
        QtdDet=zeros(size(t));
        for i=1:size(Peso,1);
            for j=1:size(Sujeira,1);
                w=min(TRAP(t(p),Peso(i,:)),TRI(t(s),Sujeira(j,:)));
                QtdDet=max(QtdDet,min(w,TRAP(t,Detergente(Rules(i,j),:))));
            end
        end
        y(p,s)=sum(t.*QtdDet)/sum(QtdDet);
    end
end

surf(t,t,y);
xlabel('peso');
ylabel('sujeira');
zlabel('detergente');

print -depsc surfwm.eps